%% Here the fitting criterion is implemented. 
% This is an example of RMSE criterion

function out = mse(input_parameters)

% voltage, current, and time vector of the reference data.

v_ref   = % Insert the voltage vector of the reference data. 
i_ref   = % Insert the current vectore of the reference data.
t_ref   = % Insert the time steps vector of the reference data.

% Define the parameters of the model.
D       =  % Device length. 
x_init  =  % init value for state variable [0,D].
iv      =  % I-V relationship, linear = 0, exponential=1.

% Define your input
v_input     = v_ref; 
t_vec       = t_ref;

N=length(t_vec);

% Run the desired model in this case the team_op_model is used.
[v_model,i_model,~]=team_op_model(v_input,t_vec,x_init,iv,input_parameters);

% The output is the RMSE in this case. The algorithms will try to minimize
% this output using a pointer the function mse using @mse in the run script
out     =   sqrt(( (sum((v_model-v_ref).^2)/sum(v_ref.^2)) +...
            (sum((i_model-i_ref).^2)/sum(i_ref.^2)) )/N);

end